/*
 * JS for LiveStreaming generated by Appery.io
 */

Apperyio.getProjectGUID = function() {
    return '640ba57f-4311-48ef-9c04-e02e5f31d5b9';
};

function navigateTo(outcome, useAjax) {
    Apperyio.navigateTo(outcome, useAjax);
}

// Deprecated


function adjustContentHeight() {
    Apperyio.adjustContentHeightWithPadding();
}

function adjustContentHeightWithPadding(_page) {
    Apperyio.adjustContentHeightWithPadding(_page);
}

function setDetailContent(pageUrl) {
    Apperyio.setDetailContent(pageUrl);
}

Apperyio.AppPages = [{
    "name": "Tuesday",
    "location": "Tuesday.html"
}, {
    "name": "LiveStreaming",
    "location": "LiveStreaming.html"
}, {
    "name": "Thursday",
    "location": "Thursday.html"
}, {
    "name": "feedback",
    "location": "feedback.html"
}, {
    "name": "Monday",
    "location": "Monday.html"
}, {
    "name": "LatestVideosFixed",
    "location": "LatestVideosFixed.html"
}, {
    "name": "Friday",
    "location": "Friday.html"
}, {
    "name": "WatchShowsFixed",
    "location": "WatchShowsFixed.html"
}, {
    "name": "Saturday",
    "location": "Saturday.html"
}, {
    "name": "Wednesday",
    "location": "Wednesday.html"
}, {
    "name": "startScreen",
    "location": "startScreen.html"
}, {
    "name": "articles",
    "location": "articles.html"
}, {
    "name": "Sunday",
    "location": "Sunday.html"
}];

LiveStreaming_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'mobilebutton_12': 'LiveStreaming_mobilebutton_12',
        'mobileworkarea_33': 'LiveStreaming_mobileworkarea_33',
        'youtube_34': 'LiveStreaming_youtube_34',
        'mobilegrid_16': 'LiveStreaming_mobilegrid_16',
        'mobilegridcell_17': 'LiveStreaming_mobilegridcell_17',
        'mobilebutton_23': 'LiveStreaming_mobilebutton_23',
        'mobilegridcell_18': 'LiveStreaming_mobilegridcell_18',
        'mobilelabel_21': 'LiveStreaming_mobilelabel_21',
        'mobilebutton_30': 'LiveStreaming_mobilebutton_30',
        'mobilebutton_29': 'LiveStreaming_mobilebutton_29',
        'mobilebutton_15': 'LiveStreaming_mobilebutton_15',
        'mobilebutton_14': 'LiveStreaming_mobilebutton_14',
        'mobilebutton_31': 'LiveStreaming_mobilebutton_31',
        'mobilebutton_32': 'LiveStreaming_mobilebutton_32',
        'mobilegrid_35': 'LiveStreaming_mobilegrid_35',
        'mobilegridcell_36': 'LiveStreaming_mobilegridcell_36',
        'mobilelabel_41': 'LiveStreaming_mobilelabel_41',
        'mobilegridcell_37': 'LiveStreaming_mobilegridcell_37',
        'mobilebutton_40': 'LiveStreaming_mobilebutton_40',
        'mobilebutton_42': 'LiveStreaming_mobilebutton_42',
        'mobilebutton_43': 'LiveStreaming_mobilebutton_43',
        'mobilebutton_44': 'LiveStreaming_mobilebutton_44',
        'mobilebutton_45': 'LiveStreaming_mobilebutton_45',
        'mobilebutton_47': 'LiveStreaming_mobilebutton_47',
        'mobilebutton_46': 'LiveStreaming_mobilebutton_46',
        'mobilebutton_48': 'LiveStreaming_mobilebutton_48'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'LiveStreaming';

    /*
     * Nonvisual components
     */
    var datasources = [];

    caroselData = new Apperyio.DataSource(LatestVideos, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("LiveStreaming");
        },
        'onSuccess': function(data) {},
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [],
        'requestMapping': [{
            'PATH': ['appery-proxy-url'],
            'HEADER': true,
            'ATTR': 'https://gdata.youtube.com/feeds/api/users/hudatv/uploads?start-index=1&max-results=10'
        }, {
            'PATH': ['appery-transformation'],
            'HEADER': true,
            'ATTR': 'checkTunnel'
        }, {
            'PATH': ['appery-key'],
            'HEADER': true,
            'ATTR': '1404093950445'
        }, {
            'PATH': ['appery-rest'],
            'HEADER': true,
            'ATTR': '5e1017d8-2c32-4a5b-8372-10346eb91c9c'
        }]
    });

    datasources.push(caroselData);

    /*
     * Events and handlers
     */

    // Before Show
    var LiveStreaming_beforeshow = function() {
            Apperyio.CurrentScreen = "LiveStreaming";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var LiveStreaming_onLoad = function() {
            LiveStreaming_elementsExtraJS();

            try {
                caroselData.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            LiveStreaming_deviceEvents();
            LiveStreaming_windowEvents();
            LiveStreaming_elementsEvents();
        };

    // screen window events
    var LiveStreaming_windowEvents = function() {

            $('#LiveStreaming').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var LiveStreaming_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var LiveStreaming_elementsExtraJS = function() {
            // screen (LiveStreaming) extra code

            Apperyio.registerYoutubeComponent("LiveStreaming_youtube_34");

        };

    // screen elements handler
    var LiveStreaming_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#LiveStreaming_mobileheader1 [name="mobilebutton_12"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="LiveStreaming_panel_13"]').panel("open");

                    }
                },
            }, '#LiveStreaming_mobileheader1 [name="mobilebutton_12"]');

            $(document).off("click", '[name="mobilebutton_23"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio("panel_13").panel("close");

                    }
                },
            }, '[name="mobilebutton_23"]');

            $(document).off("click", '[name="mobilebutton_30"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="LiveStreaming_panel_34"]').panel("open");

                    }
                },
            }, '[name="mobilebutton_30"]');
            $(document).off("click", '[name="mobilebutton_29"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('articles', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_29"]');
            $(document).off("click", '[name="mobilebutton_15"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('LatestVideosFixed', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_15"]');
            $(document).off("click", '[name="mobilebutton_14"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('WatchShowsFixed', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_14"]');
            $(document).off("click", '[name="mobilebutton_31"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        window.top.location = 'https://www.youtube.com/v/qOqUSleoHdc?version=3&f=user_uploads&app=youtube_gdata';

                    }
                },
            }, '[name="mobilebutton_31"]');
            $(document).off("click", '[name="mobilebutton_32"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('feedback', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_32"]');

            $(document).off("click", '[name="mobilebutton_42"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Sunday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_42"]');
            $(document).off("click", '[name="mobilebutton_43"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Monday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_43"]');
            $(document).off("click", '[name="mobilebutton_44"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Tuesday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_44"]');
            $(document).off("click", '[name="mobilebutton_45"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Wednesday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_45"]');
            $(document).off("click", '[name="mobilebutton_47"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Thursday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_47"]');
            $(document).off("click", '[name="mobilebutton_46"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Friday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_46"]');
            $(document).off("click", '[name="mobilebutton_48"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Saturday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_48"]');

        };

    $(document).off("pagebeforeshow", "#LiveStreaming").on("pagebeforeshow", "#LiveStreaming", function(event, ui) {
        LiveStreaming_beforeshow();
    });

    if (runBeforeShow) {
        LiveStreaming_beforeshow();
    } else {
        LiveStreaming_onLoad();
    }
};

$(document).off("pagecreate", "#LiveStreaming").on("pagecreate", "#LiveStreaming", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    LiveStreaming_js();
});