/*
 * JS for articles generated by Appery.io
 */

Apperyio.getProjectGUID = function() {
    return '640ba57f-4311-48ef-9c04-e02e5f31d5b9';
};

function navigateTo(outcome, useAjax) {
    Apperyio.navigateTo(outcome, useAjax);
}

// Deprecated


function adjustContentHeight() {
    Apperyio.adjustContentHeightWithPadding();
}

function adjustContentHeightWithPadding(_page) {
    Apperyio.adjustContentHeightWithPadding(_page);
}

function setDetailContent(pageUrl) {
    Apperyio.setDetailContent(pageUrl);
}

Apperyio.AppPages = [{
    "name": "Tuesday",
    "location": "Tuesday.html"
}, {
    "name": "LiveStreaming",
    "location": "LiveStreaming.html"
}, {
    "name": "Thursday",
    "location": "Thursday.html"
}, {
    "name": "feedback",
    "location": "feedback.html"
}, {
    "name": "Monday",
    "location": "Monday.html"
}, {
    "name": "LatestVideosFixed",
    "location": "LatestVideosFixed.html"
}, {
    "name": "Friday",
    "location": "Friday.html"
}, {
    "name": "WatchShowsFixed",
    "location": "WatchShowsFixed.html"
}, {
    "name": "Saturday",
    "location": "Saturday.html"
}, {
    "name": "Wednesday",
    "location": "Wednesday.html"
}, {
    "name": "startScreen",
    "location": "startScreen.html"
}, {
    "name": "articles",
    "location": "articles.html"
}, {
    "name": "Sunday",
    "location": "Sunday.html"
}];

articles_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'mobilebutton_12': 'articles_mobilebutton_12',
        'mobileworkarea_33': 'articles_mobileworkarea_33',
        'mobilelabel_49': 'articles_mobilelabel_49',
        'repeater': 'articles_repeater',
        'mobilegridcell_56': 'articles_mobilegridcell_56',
        'title': 'articles_title',
        'description': 'articles_description',
        'mobilelink_53': 'articles_mobilelink_53',
        'spacer_54': 'articles_spacer_54',
        'mobilegrid_16': 'articles_mobilegrid_16',
        'mobilegridcell_17': 'articles_mobilegridcell_17',
        'mobilebutton_23': 'articles_mobilebutton_23',
        'mobilegridcell_18': 'articles_mobilegridcell_18',
        'mobilelabel_21': 'articles_mobilelabel_21',
        'mobilebutton_30': 'articles_mobilebutton_30',
        'mobilebutton_29': 'articles_mobilebutton_29',
        'mobilebutton_15': 'articles_mobilebutton_15',
        'mobilebutton_14': 'articles_mobilebutton_14',
        'mobilebutton_31': 'articles_mobilebutton_31',
        'mobilebutton_32': 'articles_mobilebutton_32',
        'mobilegrid_35': 'articles_mobilegrid_35',
        'mobilegridcell_36': 'articles_mobilegridcell_36',
        'mobilelabel_41': 'articles_mobilelabel_41',
        'mobilegridcell_37': 'articles_mobilegridcell_37',
        'mobilebutton_40': 'articles_mobilebutton_40',
        'mobilebutton_42': 'articles_mobilebutton_42',
        'mobilebutton_43': 'articles_mobilebutton_43',
        'mobilebutton_44': 'articles_mobilebutton_44',
        'mobilebutton_45': 'articles_mobilebutton_45',
        'mobilebutton_47': 'articles_mobilebutton_47',
        'mobilebutton_46': 'articles_mobilebutton_46',
        'mobilebutton_48': 'articles_mobilebutton_48'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'articles';

    /*
     * Nonvisual components
     */
    var datasources = [];

    articleData = new Apperyio.DataSource(Articles, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {

            Apperyio.refreshScreenFormElements("articles");
        },
        'onSuccess': function(data) {},
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['rss', 'channel', 'item'],
            'ID': 'repeater',
            'SET': [{
                'PATH': ['title'],
                'ID': 'title',
                'ATTR': '@'
            }, {
                'PATH': ['link'],
                'ID': 'mobilelink_53',
                'ATTR': 'href'
            }, {
                'PATH': ['description'],
                'ID': 'description',
                'ATTR': '@'
            }]
        }],
        'requestMapping': [{
            'PATH': ['appery-proxy-url'],
            'HEADER': true,
            'ATTR': 'http://huda.tv/new/category/articles/what-is-islam/feed/'
        }, {
            'PATH': ['appery-transformation'],
            'HEADER': true,
            'ATTR': 'checkTunnel'
        }, {
            'PATH': ['appery-key'],
            'HEADER': true,
            'ATTR': '1404093954370'
        }, {
            'PATH': ['appery-rest'],
            'HEADER': true,
            'ATTR': 'b3d45eec-e060-412f-ae89-4949290b690d'
        }]
    });

    datasources.push(articleData);

    /*
     * Events and handlers
     */

    // Before Show
    var articles_beforeshow = function() {
            Apperyio.CurrentScreen = "articles";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var articles_onLoad = function() {
            articles_elementsExtraJS();

            try {
                articleData.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };
            try {
                caroselData.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            articles_deviceEvents();
            articles_windowEvents();
            articles_elementsEvents();
        };

    // screen window events
    var articles_windowEvents = function() {

            $('#articles').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var articles_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var articles_elementsExtraJS = function() {
            // screen (articles) extra code

        };

    // screen elements handler
    var articles_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#articles_mobileheader1 [name="mobilebutton_12"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="articles_panel_13"]').panel("open");

                    }
                },
            }, '#articles_mobileheader1 [name="mobilebutton_12"]');

            $(document).off("click", '[name="mobilebutton_23"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio("panel_13").panel("close");

                    }
                },
            }, '[name="mobilebutton_23"]');

            $(document).off("click", '[name="mobilebutton_30"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="articles_panel_34"]').panel("open");

                    }
                },
            }, '[name="mobilebutton_30"]');
            $(document).off("click", '[name="mobilebutton_29"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('articles', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_29"]');
            $(document).off("click", '[name="mobilebutton_15"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('LatestVideosFixed', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_15"]');
            $(document).off("click", '[name="mobilebutton_14"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('WatchShowsFixed', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_14"]');
            $(document).off("click", '[name="mobilebutton_31"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        window.top.location = 'https://www.youtube.com/v/qOqUSleoHdc?version=3&f=user_uploads&app=youtube_gdata';

                    }
                },
            }, '[name="mobilebutton_31"]');
            $(document).off("click", '[name="mobilebutton_32"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('feedback', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_32"]');

            $(document).off("click", '[name="mobilebutton_42"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Sunday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_42"]');
            $(document).off("click", '[name="mobilebutton_43"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Monday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_43"]');
            $(document).off("click", '[name="mobilebutton_44"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Tuesday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_44"]');
            $(document).off("click", '[name="mobilebutton_45"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Wednesday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_45"]');
            $(document).off("click", '[name="mobilebutton_47"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Thursday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_47"]');
            $(document).off("click", '[name="mobilebutton_46"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Friday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_46"]');
            $(document).off("click", '[name="mobilebutton_48"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Saturday', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_48"]');

        };

    $(document).off("pagebeforeshow", "#articles").on("pagebeforeshow", "#articles", function(event, ui) {
        articles_beforeshow();
    });

    if (runBeforeShow) {
        articles_beforeshow();
    } else {
        articles_onLoad();
    }
};

$(document).off("pagecreate", "#articles").on("pagecreate", "#articles", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    articles_js();
});