/*
 * JS for feedback generated by Appery.io
 */

Apperyio.getProjectGUID = function() {
    return '640ba57f-4311-48ef-9c04-e02e5f31d5b9';
};

function navigateTo(outcome, useAjax) {
    Apperyio.navigateTo(outcome, useAjax);
}

// Deprecated


function adjustContentHeight() {
    Apperyio.adjustContentHeightWithPadding();
}

function adjustContentHeightWithPadding(_page) {
    Apperyio.adjustContentHeightWithPadding(_page);
}

function setDetailContent(pageUrl) {
    Apperyio.setDetailContent(pageUrl);
}

Apperyio.AppPages = [{
    "name": "startScreen",
    "location": "startScreen.html"
}, {
    "name": "LiveStreaming",
    "location": "LiveStreaming.html"
}, {
    "name": "feedback",
    "location": "feedback.html"
}, {
    "name": "LatestVideos",
    "location": "LatestVideos.html"
}, {
    "name": "WatchShows",
    "location": "WatchShows.html"
}];

feedback_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'mobilebutton_12': 'feedback_mobilebutton_12',
        'mobileworkarea_33': 'feedback_mobileworkarea_33',
        'html_34': 'feedback_html_34',
        'mobilelabel_42': 'feedback_mobilelabel_42',
        'mobilelabel_35': 'feedback_mobilelabel_35',
        'mobiletextinput_36': 'feedback_mobiletextinput_36',
        'mobilelabel_37': 'feedback_mobilelabel_37',
        'mobiletextinput_38': 'feedback_mobiletextinput_38',
        'mobilelabel_39': 'feedback_mobilelabel_39',
        'mobiletextarea_40': 'feedback_mobiletextarea_40',
        'mobilebutton_41': 'feedback_mobilebutton_41',
        'mobilegrid_16': 'feedback_mobilegrid_16',
        'mobilegridcell_17': 'feedback_mobilegridcell_17',
        'mobilebutton_23': 'feedback_mobilebutton_23',
        'mobilegridcell_18': 'feedback_mobilegridcell_18',
        'mobilelabel_21': 'feedback_mobilelabel_21',
        'mobilebutton_29': 'feedback_mobilebutton_29',
        'mobilebutton_30': 'feedback_mobilebutton_30',
        'mobilebutton_15': 'feedback_mobilebutton_15',
        'mobilebutton_14': 'feedback_mobilebutton_14',
        'mobilebutton_31': 'feedback_mobilebutton_31',
        'mobilebutton_32': 'feedback_mobilebutton_32'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'feedback';

    /*
     * Nonvisual components
     */
    var datasources = [];

    /*
     * Events and handlers
     */

    // Before Show
    var feedback_beforeshow = function() {
            Apperyio.CurrentScreen = "feedback";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var feedback_onLoad = function() {
            feedback_elementsExtraJS();

            try {
                caroselData.execute({})
            } catch (ex) {
                console.log(ex.name + '  ' + ex.message);
                hideSpinner();
            };

            // TODO fire device events only if necessary (with JS logic)
            feedback_deviceEvents();
            feedback_windowEvents();
            feedback_elementsEvents();
        };

    // screen window events
    var feedback_windowEvents = function() {

            $('#feedback').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var feedback_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var feedback_elementsExtraJS = function() {
            // screen (feedback) extra code

        };

    // screen elements handler
    var feedback_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("click", '#feedback_mobileheader1 [name="mobilebutton_12"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        $('[id="feedback_panel_13"]').panel("open");

                    }
                },
            }, '#feedback_mobileheader1 [name="mobilebutton_12"]');

            $(document).off("click", '[name="mobilebutton_23"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio("panel_13").panel("close");

                    }
                },
            }, '[name="mobilebutton_23"]');

            $(document).off("click", '[name="mobilebutton_15"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('LatestVideos', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_15"]');
            $(document).off("click", '[name="mobilebutton_14"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('WatchShows', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_14"]');
            $(document).off("click", '[name="mobilebutton_31"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('LiveStreaming', {
                            transition: 'slide',
                            reverse: false
                        });

                    }
                },
            }, '[name="mobilebutton_31"]');

        };

    $(document).off("pagebeforeshow", "#feedback").on("pagebeforeshow", "#feedback", function(event, ui) {
        feedback_beforeshow();
    });

    if (runBeforeShow) {
        feedback_beforeshow();
    } else {
        feedback_onLoad();
    }
};

$(document).off("pagecreate", "#feedback").on("pagecreate", "#feedback", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    feedback_js();
});